package com.cloudpos.webviewcallsdk;

import android.content.Context;
import android.util.Log;
import android.webkit.JavascriptInterface;
import android.widget.Toast;

import com.cloudpos.DeviceException;
import com.cloudpos.POSTerminal;
import com.cloudpos.printer.PrinterDevice;

public class MyJavascriptInterface {
    private Context context;

    public MyJavascriptInterface(Context context) {
        this.context = context;
    }

    /**
     * 网页使用的js，方法无参数
     * 名应和js函数方法名一致
     */
    @JavascriptInterface
    public void startFunction() {
        Log.e("startFunction", "----no param");
        Toast.makeText(context, "no params", Toast.LENGTH_SHORT).show();
        PrinterDevice device = (PrinterDevice) POSTerminal.getInstance(context).getDevice("cloudpos.device.printer");
        try {
            device.open();
            device.printText("无参函数无参函数无参函数无参函数无参函数无参函数无参函数无参函数无参函数无参函数");
            device.close();
        } catch (DeviceException e) {
            e.printStackTrace();
        }
    }

    /**
     * 网页使用的js，方法有参数，且参数名为data
     *
     * @param data 网页js里的参数名
     */
    @JavascriptInterface
    public void startFunction(String data) {
        Log.e("startFunction", "----have param\n" + data);
        if (!data.isEmpty()) {
            PrinterDevice device = (PrinterDevice) POSTerminal.getInstance(context).getDevice("cloudpos.device.printer");
            try {
                device.open();
                device.printText(data);
                device.close();
            } catch (DeviceException e) {
                e.printStackTrace();
            }
        } else {
            Toast.makeText(context, "content is blank", Toast.LENGTH_SHORT).show();
        }
    }
}